import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Beach here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Beach extends World
{
    public static boolean gameEnded = false;
    
    private int[] lobsterX = {185, 135, 393, 295};
    private int[] lobsterY = {70, 432, 105, 240};
    
    /**
     * Constructor for objects of class Beach.
     * 
     */
    public Beach()
    {    
        // Create a new world with 512x512 cells with a cell size of 1x1 pixels.
        super(512, 511, 1); 
        setPaintOrder(EndGame.class, Water.class, Lobster.class, Crabbie.class, Fish.class);
        gameEnded = false;
        prepare();
    }

    public void act()
    {
        if (gameEnded)
        {
            EndGame ending = new EndGame();
            addObject(ending, 256, 255);
            Greenfoot.stop();
        }

        List allFish = getObjects(Fish.class);
        if (allFish.isEmpty())
        {
            EndGame.title = "You're a winner!";
            Greenfoot.playSound("success.wav");
            EndGame ending = new EndGame();
            addObject(ending, 256, 255);
            Greenfoot.stop();
        }
    }

    /**
     * Add our creatures.
     */
    private void prepare()
    {
        addObject(new Water(), 504, 255);
        
        for (int val = 0; val < 12; val++)
        {
            addObject(new Fish(), Greenfoot.getRandomNumber(511), Greenfoot.getRandomNumber(511));
        }
        
        for (int val = 0; val < 4; val++)
        {
            addObject(new Lobster(), lobsterX[val], lobsterY[val]);
        }

        addObject(new Crabbie(), 71, 277);
    }
}
