import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Crabbie here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Crabbie extends Creatures
{
    private GreenfootImage crab1 = new GreenfootImage("crabbie.png");
    private GreenfootImage crab2 = new GreenfootImage("crabbie-b.png");
    private GreenfootImage crab3 = new GreenfootImage("crabbie.png");
    private GreenfootImage crab4 = new GreenfootImage("crabbie-c.png");

    private int currentImage;
    private int animateHold;

    public Crabbie()
    {
        turn(Greenfoot.getRandomNumber(89));
        setImage(crab1);
        currentImage = 1;
    }

    /**
     * Act - do whatever the Crabbie wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        keyboardControl();
        lookForFish();

    }    

    /**
     * See if user is controlling the crabbie.
     */
    public void keyboardControl() 
    {

        if (Greenfoot.isKeyDown("up"))
        {
            super.move(2);

            if (animateHold == 4)
            {
                updateImage();
                animateHold = 0;
            }
            else
            {
                animateHold ++;
            }

        }

        if (Greenfoot.isKeyDown("down"))
        {
            super.move(-2);

            if (animateHold == 4)
            {
                updateImage();
                animateHold = 0;
            }
            else
            {
                animateHold ++;
            }

        }

        if (Greenfoot.isKeyDown("right"))
        {
            turn(3);

            if (animateHold == 4)
            {
                updateImage();
                animateHold = 0;
            }
            else
            {
                animateHold ++;
            }
        }

        if (Greenfoot.isKeyDown("left"))
        {
            turn(-3);

            if (animateHold == 4)
            {
                updateImage();
                animateHold = 0;
            }
            else
            {
                animateHold ++;
            }
        }
    }

    /**
     * See if we can eat a fish.
     */
    public void lookForFish() 
    {
        if (canSee(Fish.class))
        {
            eat(Fish.class);
            Greenfoot.playSound("nom.wav");
        }
    }   

    /**
     * Animate Crabbie
     */
    public void updateImage()
    {
        switch (currentImage)
        {
            case 1:
            setImage(crab2);
            currentImage = 2;
            break;
            case 2:
            setImage(crab3);
            currentImage = 3;
            break;
            case 3:
            setImage(crab4);
            currentImage = 4;
            break;
            case 4:
            setImage(crab1);
            currentImage = 1;
            break;
        }
    }
}
