import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Creatures here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Creatures extends Actor
{
    /**
     * Test if we are close to one of the edges of the
     * world and return true if we are.
     */
    public boolean atWorldEdge()
    {
        World w = getWorld();
        if (getX() == 5 || getX() == w.getWidth() - 5)
        {
            return true;
        }
        if (getY() == 5 || getY() == w.getHeight() - 5)
        {
            return true;
        }
        return false;
    }

    /**
     * Move our characters randomly.
     */

    private int turnAmountCurrent = 0;
    private int wiggle = 1;
    private int turnAmount = 60;
    private boolean moving = true;
    private int moved = 0;

    public void randomMove()
    {
        if (atWorldEdge())
        {
            moving = false;
            moved = 0;
        }

        if (moving == false)
        {
            if (moved < 89)
            {
                turn(1);
                move(1);
                moved++;
            }
            if (moved == 89)
            {
                move(3);
                moving = true;
            }
        }
        else
        {
            move(1);
            if (atWorldEdge() == false)
            {
                turn(wiggle);
            }
            if (turnAmountCurrent == turnAmount)
            {
                wiggle = wiggle * -1;
                turnAmountCurrent = 0;
                turnAmount = Greenfoot.getRandomNumber(100) + 1;
            }
            turnAmountCurrent++;
        }
    }

    /**
     * Return true if we can see an object of class 'clss'
     * right where we are.
     * False if there is no such object here.
     */
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;
    }

    /**
     * Try to eat an object of class 'clss'. This is only
     * successful if there is such an object at the current
     * location. Otherwise this method does nothing.
     */
    public void eat(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if (actor != null) {
            getWorld().removeObject(actor);
        }
    }

}
